local spartan = LibStub("AceAddon-3.0"):GetAddon("SpartanUI");
local L = LibStub("AceLocale-3.0"):GetLocale("SpartanUI_Animated", true);
local Smooth = LibStub("LibSmoothStatusBar-1.0")
local AceConfig = LibStub("AceConfig-3.0");
local AceConfigDialog = LibStub("AceConfigDialog-3.0");
local addon = spartan:NewModule("Animation");

addon.optionsAnimation = {name = "Animation", type = "group", args = {}};

local t_power = { };
local lUnitExists = UnitExists
local lUnitPowerType = UnitPowerType
local powerTable = {[0] ={},[1] ={},[2] ={},[3] ={},[4] ={},[5] ={},[6] ={}, [7] ={}, [8] ={}, }
local s_table = {
	["player"] = SUI_PlayerFrame,
	["target"] = SUI_targetFrame,
	["pet"]	 = SUI_petFrame,
	["focus"]  = SUI_focusFrame,	  
	["focustarget"] = SUI_focustargetFrame,
};
local s_table_party = {};
--[[ --  default values for another time
DBdefault.Modules.Animation = {
			enable = true,
			animationInterval = 0,
			animationIntervalStop = 0.15,
			health = "interface\\addons\\SpartanUI_Animated\\Animations\\Health\\HealthBar",
			mana = "interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar",
			cast = "interface\\addons\\SpartanUI_Animated\\Animations\\Cast\\CastBar",
			focus = "interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar", 
			runicpower = "interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar",
			energy = "interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar",
			rage = "interface\\addons\\SpartanUI_Animated\\Animations\\Rage\\RageBar",
			} ]]
			
function addon:OnInitialize()
	local textures = {["interface\\addons\\SpartanUI_Animated\\Animations\\Health\\HealthBar"] = L["Bar/Health"],
					  ["interface\\addons\\SpartanUI_Animated\\Animations\\Cast\\CastBar"] = L["Bar/Casting"],
					  ["interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar"] = L["Bar/Mana"],
					  ["interface\\addons\\SpartanUI_Animated\\Animations\\Rage\\RageBar"] = L["Bar/Rage"],
					  ["interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar"] = L["Bar/Energy"]}
					  
	addon.optionsAnimation.args = {
		enable = {name=L["Animation/Enabled"],type="toggle",order=1,width="full",
			get = function(info) return SDBMod.Animation.enable end,
			set = function(info,val) SDBMod.Animation.enable = val end
		},
		enableinfo = {name=L["Animation/ReloadRequired"],type="description",order=2},		
		health = {name=L["BarTexture/Health"],type="select",order=5,
			style="dropdown",values=textures,
			get = function(info) return SDBMod.Animation.health or t_power[7] end,
			set = function(info,val) SDBMod.Animation.health = val; addon:SetAnimationTexture(7,val) end
		},
		cast = {name=L["BarTexture/Casting"],type="select",order=6,
			style="dropdown",values=textures,
			get = function(info) return SDBMod.Animation.cast or t_power[8]  end,
			set = function(info,val) SDBMod.Animation.cast = val; addon:SetAnimationTexture(8,val) end
		},
		mana = {name=L["BarTexture/Mana"],type="select",order=7,
			style="dropdown",values=textures,
			get = function(info) return SDBMod.Animation.mana or t_power[0] end,
			set = function(info,val) SDBMod.Animation.mana = val; addon:SetAnimationTexture(0,val) end
		},
		rage = {name=L["BarTexture/Rage"],type="select",order=8,
			style="dropdown",values=textures,
			get = function(info) return SDBMod.Animation.rage or t_power[1]  end,
			set = function(info,val) SDBMod.Animation.rage = val; addon:SetAnimationTexture(1,val) end
		},
		energy = {name=L["BarTexture/Energy"],type="select",order=9,
			style="dropdown",values=textures,
			get = function(info) return SDBMod.Animation.energy or t_power[3]  end,
			set = function(info,val) SDBMod.Animation.energy = val; addon:SetAnimationTexture(3,val) end
		},
		focus = {name=L["BarTexture/Focus"],type="select",order=10,
			style="dropdown",values=textures,
			get = function(info) return SDBMod.Animation.focus or t_power[4]  end,
			set = function(info,val) SDBMod.Animation.focus = val;addon:SetAnimationTexture(4,val) end
		},
		runicpower = {name=L["BarTexture/RunicPower"],type="select",order=11,
			style="dropdown",values=textures,
			get = function(info) return SDBMod.Animation.runicpower or t_power[6] end,
			set = function(info,val) SDBMod.Animation.runicpower = val; addon:SetAnimationTexture(6,val); addon:SetAnimationTexture(5,val) end
		},
		animationIntervalStop = {name=L["BarTexture/Speed"],type="range",order=12,width="double",		
			min=1, max=23, step=1,		
			get = function(info) return abs(1/tonumber(SDBMod.Animation.animationIntervalStop)) or abs(1/0.083) end,		
		set = function(info,val) SDBMod.Animation.animationIntervalStop = abs(1/tonumber(val)) end
		},
		resetframes = {name = L["Bars/resetall"],type = "execute",order=13,
			desc = L["Bars/resetallDesc"],
			func = function() addon:Refresh(); end
		},
		reloadframes = {name = L["Bars/reloadall"],type = "execute",order=14,
			desc = L["Bars/reloadDesc"],
			func = function() ReloadUI(); end
		},
	};
end

function addon:OnEnable()
	f = CreateFrame("Frame", "Animation", WorldFrame);
	AceConfig:RegisterOptionsTable("Animation", addon.optionsAnimation)
	if spartan:GetModule("Animation", true) then AceConfigDialog:AddToBlizOptions("Animation", L["Animation"], "SpartanUI") end		
	f:SetFrameStrata("BACKGROUND");
	f:RegisterEvent("PLAYER_ENTERING_WORLD");
	f:RegisterEvent("GROUP_ROSTER_UPDATE");
	if (SDBMod.Animation.enable) then
		SUI_PlayerFrame.Castbar:SetStatusBarColor(1,1,1,1);	
		f:SetScript("OnEvent", function(this, event, ...) addon[event](addon, ...) end);
		f:SetScript("OnUpdate", function(self, elapsed) addon:Update(self, elapsed) end);		
	else
		addon:PLAYER_ENTERING_WORLD();
	end		
end

function addon:PLAYER_ENTERING_WORLD()
    if not (SDBMod) then SDBMod = { Animation = { enable = true, animationInterval = 0, animationIntervalStop = 0.15 } } end	
	t_power[0] = SDBMod.Animation.mana or "interface\\addons\\SpartanUI_Animated\\Animations\\Mana\\Manabar" --"mana",
	t_power[1] = SDBMod.Animation.rage or "interface\\addons\\SpartanUI_Animated\\Animations\\Rage\\RageBar" --"rage",
	t_power[2] = SDBMod.Animation.focus or "interface\\addons\\SpartanUI_Animated\\Animations\\Energy\\EnergyBar" --"focus", 
	t_power[3] = SDBMod.Animation.energy or t_power[2] --"energy", 
	t_power[4] = SDBMod.Animation.focus or t_power[2] --"happiness", 
	t_power[5] = SDBMod.Animation.runicpower or t_power[0] --"runes", 
	t_power[6] = SDBMod.Animation.runicpower or t_power[0] --"runic power" 
	t_power[7] = SDBMod.Animation.health or "interface\\addons\\SpartanUI_Animated\\Animations\\Health\\HealthBar"-- health unsused
	t_power[8] = SDBMod.Animation.cast or "interface\\addons\\SpartanUI_Animated\\Animations\\Cast\\CastBar"--castbar unused
	for powerType,texture in pairs(t_power) do
	  addon:SetAnimationTexture(powerType, texture)
	end
	if SDBMod.Animation.enable then
		for k, v in pairs(s_table) do
			Smooth:SmoothBar(v.Power)
			Smooth:SmoothBar(v.Health)
			if v.CastBar then
			 Smooth:SmoothBar(v.CastBar)
			end
		end
		s_table_party = { 
			["targettarget"] = SUI_targettargetFrame, --avoid nil pointers			
		};	
	end		
end

function addon:GROUP_ROSTER_UPDATE()
	
	s_table_party = { 
		["player"] = SUI_PartyFrameHeaderUnitButton1,
		["party1"] = SUI_PartyFrameHeaderUnitButton2,
		["party2"] = SUI_PartyFrameHeaderUnitButton3,
		["party3"] = SUI_PartyFrameHeaderUnitButton4,
		["party4"] = SUI_PartyFrameHeaderUnitButton5, 
		};
end

function addon:SetAnimationTexture(powerType, texture)	
	for i = 1, 40, 1 do
		powerTable[powerType][i] = texture..tostring(i)
	end
end

function addon:Refresh()
s_table_party = { 	
		["targettarget"] = SUI_targettargetFrame,--avoid nil pointers
		["player"] = SUI_PartyFrameHeaderUnitButton1,
		["party1"] = SUI_PartyFrameHeaderUnitButton2,
		["party2"] = SUI_PartyFrameHeaderUnitButton3,
		["party3"] = SUI_PartyFrameHeaderUnitButton4,
		["party4"] = SUI_PartyFrameHeaderUnitButton5, 
		};
s_table = { 
	["player"] = SUI_PlayerFrame, 
	["target"] = SUI_targetFrame,
	["pet"]	 = SUI_petFrame,
	["focus"]  = SUI_focusFrame,				  
	["focustarget"] = SUI_focustargetFrame,				  				  
};
return true
end

local AnimationUpdate = function(self,powerType)	
	local frameCount = (self.frameCount or 0) % 40 + 1
	self.frameCount = frameCount
	self:SetStatusBarTexture(powerTable[powerType][frameCount])	
	return
end

function addon:Update(self,elapsed)
	SDBMod.Animation.animationInterval = SDBMod.Animation.animationInterval + elapsed;	
	while ( SDBMod.Animation.animationInterval > SDBMod.Animation.animationIntervalStop ) do
		for unit,frame in pairs(s_table) do
			if lUnitExists(unit) and frame:IsVisible() then
				local powerType = (lUnitPowerType(unit) or 0) % 7
				AnimationUpdate(frame.Health, 7);
				AnimationUpdate(frame.Power, powerType);				
				if frame.Castbar and (frame.Castbar.casting or frame.Castbar.channeling) then					
					AnimationUpdate(frame.Castbar, 8);
				end
			end
		end	
		for unit,frame in pairs(s_table_party) do
			if lUnitExists(unit) and frame:IsVisible() then
				local powerType = (lUnitPowerType(unit) or 0) % 7
				AnimationUpdate(frame.Health, 7);
				AnimationUpdate(frame.Power, powerType);				
				if frame.Castbar and (frame.Castbar.casting or frame.Castbar.channeling) then					
					AnimationUpdate(frame.Castbar, 8);
				end
			end
		end	
		SDBMod.Animation.animationInterval = SDBMod.Animation.animationInterval - SDBMod.Animation.animationIntervalStop;
	end
	return
end